<?php

/**
 * Extra Fields Controller.
 */
class EntitypollChoiceExtraFieldsController extends EntityDefaultExtraFieldsController {

  public function fieldExtraFields() {
    $extra = parent::fieldExtraFields();

    // All bundles will have available common extra fields.
    $choice_types = entitypoll_choice_get_types();
    foreach ($choice_types as $type) {
      $extra['entitypoll_choice'][$type->name] = $extra['entitypoll_choice']['entitypoll_choice'];
      $extra['entitypoll_choice'][$type->name]['form']['label'] = $extra['entitypoll_choice'][$type->name]['display']['label'];

      // Choices need to display element generated by an entitypoll widget,
      // which determines how user will be voting.
      $extra['entitypoll_choice'][$type->name]['display']['entitypoll_choice_widget'] = array(
        'label' => t('Voting widget'),
        'description' => t('This widget allows visitor to vote on option.'),
        'weight' => 0,
      );

      $extra['entitypoll_choice'][$type->name]['display']['entitypoll_choice_result'] = array(
        'label' => t('Result'),
        'description' => t('This field display result for given option.'),
        'weight' => 0,
      );

    }

    return $extra;
  }
}